/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package AVEinfach;
import java.sql.*;


/**
 *
 * @author R. Hoppe
 */
public class Artikel {
    private String artikelNr;
	private String artikelBezeichnung;
	private String packeinheit;
    private double preis;
    private int bestand;
    private int meldebestand;

	public Artikel() {
	}
	public Artikel(String pArtikelNr, String pArtikelBezeichnung, String pPackeinheit, double pPreis) {
		this.artikelNr = pArtikelNr;
		this.artikelBezeichnung = pArtikelBezeichnung;
        this.packeinheit = pPackeinheit;
		this.preis = pPreis;
        this.bestand =0;
        this.meldebestand =0;
	}
    public Artikel(String pArtikelNr, String pArtikelBezeichnung, String pPackeinheit, double pPreis, int pBestand, int pMeldebestand) {
		this.artikelNr = pArtikelNr;
		this.artikelBezeichnung = pArtikelBezeichnung;
        this.packeinheit = pPackeinheit;
		this.preis = pPreis;
        this.bestand =pBestand;
        this.meldebestand =pMeldebestand;
	}


	public void setArtikelNr(String pArtikelNr) {
		this.artikelNr = pArtikelNr;
	}
	public String getArtikelNr() {
		return artikelNr;
	}
	public void setArtikelBezeichnung(String pArtikelBezeichnung) {
		this.artikelBezeichnung = pArtikelBezeichnung;
	}
	public String getArtikelBezeichnung() {
		return artikelBezeichnung;
	}

	public void setPreis(double pPreis) {
		this.preis = pPreis;
	}
	public double getPreis() {
		return preis;
	}
    public void setBestand(int pBestand){
        bestand = pBestand;
    }
    public int getBestand(){
        return bestand;
    }

    public void setMeldebestand(int pMeldebestand){
        meldebestand = pMeldebestand;
    }

    public int getMeldebestand(){
        return meldebestand;
    }
    public void setPackeinheit(String pPackeinheit){
        this.packeinheit = pPackeinheit;
    }
    public String getPackeinheit(){
        return packeinheit;
    }


    public boolean erfassenArtikel(){
    boolean okErfassenArtikel;
    try{
        DBZugriff dbPapAuftrag = new DBZugriff();
        dbPapAuftrag.setVerbinden();
        String mSQL = " INSERT INTO tblArtikel ( ArtikelNr, ABezeichnung, Packeinheit, EPreis, Bestand, Meldebestand )";
        mSQL = mSQL + "Values ('" + this.getArtikelNr() + "', '" + this.artikelBezeichnung + "', '" + this.getPackeinheit() + "', " + this.getPreis() + ", " + this.getBestand() + ", " + this.getMeldebestand() + ")";
        okErfassenArtikel = dbPapAuftrag.aendern(mSQL);
        System.out.println("Auf Artikelebene (Fachschicht) war das Speichern ok" );
        dbPapAuftrag.setBeenden();
        
        }
    catch(Exception e){
        okErfassenArtikel = false;
        }
    return okErfassenArtikel;
    }

    public void sucheArtikel(String pArtikelnummer){
        System.out.println("Als Suchartikelnummer wird übergeben:" + pArtikelnummer);
        String mSQL;
       
        DBZugriff dbPapAuftrag = new DBZugriff();
        dbPapAuftrag.setVerbinden();
        mSQL = "Select ArtikelNr, ABezeichnung, Packeinheit, Epreis, Bestand, Meldebestand From tblArtikel";
        mSQL = mSQL + " WHERE ArtikelNr = '" + pArtikelnummer + "';";
        System.out.println(mSQL);
        ResultSet rsA = dbPapAuftrag.lesen(mSQL);
        try{
            rsA.next();

            String nr = rsA.getString(1);
            setArtikelNr(nr);
            String bez = rsA.getString(2);
            setArtikelBezeichnung(bez);
            String pack = rsA.getString(3);
            setPackeinheit(pack);
            double pr = rsA.getDouble(4);
            setPreis(pr);
            int best = rsA.getInt(5);
            setBestand(best);
            int melde = rsA.getInt(6);
            setMeldebestand(melde);

        }
        catch(Exception e){
            System.out.println("Kein Datensatz mit der Artikelnummer gefunden." + e.toString());
            setArtikelNr("nicht gefunden");
        }
        finally{
            dbPapAuftrag.setBeenden();

        }

}
    public boolean aendereArtikel(){
        boolean okAendernArtikel;
        try{
        DBZugriff dbPapAuftrag = new DBZugriff();
        dbPapAuftrag.setVerbinden();
        String sql = "UPDATE tblArtikel SET tblArtikel.ABezeichnung = '" + artikelBezeichnung + "', Packeinheit = ' " + packeinheit + "' , EPreis = " + preis + ", Bestand = " + bestand + ", Meldebestand = " + meldebestand ;
        sql = sql + " WHERE ArtikelNr = '" + artikelNr + "';";
        System.out.println(sql);
        okAendernArtikel= dbPapAuftrag.aendern(sql);
        dbPapAuftrag.setBeenden();
                }
        catch(Exception e){
            okAendernArtikel = false;
        }

        return okAendernArtikel;

    }
    public boolean loescheArtikel(){
        
        boolean okLoeschenArtikel;
        try {
        DBZugriff dbPapAuftrag = new DBZugriff();
        dbPapAuftrag.setVerbinden();
        String sql = "Delete * from tblArtikel  WHERE ArtikelNr = '" + artikelNr + "';";
        System.out.println(sql);
        okLoeschenArtikel = dbPapAuftrag.aendern(sql);
        dbPapAuftrag.setBeenden();
        }
        catch(Exception e){
            okLoeschenArtikel = false;
        }

        return okLoeschenArtikel;

    }
}